#include "stdafx.h"
#include "CelestialBody.h"

void OnDisplay();
void OnReshape(int width, int height);
void OnIdle();
void Init();
void keyboard(unsigned char key, int x, int y);
void mouse(int button, int state,int x, int y);
void onClick(void *font);
void strokeString (float x, float y, float z, float ht, char * s);
int GetTime();

CCelestialBody* pSun;

int main(int argc, char** argv)
{
	glutInit(&argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB);
	glutInitWindowSize(640, 480);
	glutCreateWindow("Solar System");

	Init();
    glutKeyboardFunc(keyboard);
    glutMouseFunc(mouse);
	glutDisplayFunc(OnDisplay);
	glutReshapeFunc(OnReshape);
	glutKeyboardFunc(keyboard);
	glutMouseFunc(mouse);
	glutIdleFunc(OnIdle);
	glutMainLoop();

	if (pSun)
		delete pSun;

	return 1;
}

void CreateSolarSystem()
{
	pSun = new CCelestialBody;
	float pSunEmission[] = {0.5, 0.5, 0.0, 1.0};
	float pAmb[] = {1.0, 1.0, 1.0, 1.0};
	float pTiltAxis[] = {0.75, 0.0, 0.75};
	float pTiltAxis2[] = {-0.75, 0.0, 0.75};
	float pTiltAxis3[] = {1.0, 0.0, 0.0};
	
	CCelestialBody* pPlanet = pSun->CreateChild();
	CCelestialBody* pMoon;
	//1
	
	pSun->SetMaterialProperty(GL_EMISSION, pSunEmission);
	pSun->SetMaterialProperty(GL_AMBIENT_AND_DIFFUSE, pSunEmission);
	pSun->SetSun(true);
	pSun->SetSunLight(GL_LIGHT1);
	pSun->SetPlanetName("Sirius");
	pSun->SetRadius(2.0);
	pSun->SetRotationalSpeed(20.0);
//2
	pPlanet->SetPlanetName("Bellatrix");
	pPlanet->SetOrbitDistance(4.5);
	pPlanet->SetRadius(0.35);
	pPlanet->SetOrbitSpeed(50.0);
	pPlanet->SetMaterialProperty(GL_AMBIENT_AND_DIFFUSE,pAmb);
	pPlanet->SetRotationalSpeed(60.0);
	pPlanet->SetResolution(20, 20);
//3
	pPlanet = pSun->CreateChild();
	pPlanet->SetPlanetName("Mesarthim");
	pPlanet->SetOrbitDistance(7.5);
	pPlanet->SetRadius(0.5);
	pPlanet->SetOrbitSpeed(85.0);
	pPlanet->SetMaterialProperty(GL_AMBIENT_AND_DIFFUSE,pAmb);
	pPlanet->SetRotationalSpeed(50.0);
	pPlanet->SetPlaneTilt(20.0, pTiltAxis);
	pPlanet->SetResolution(20, 20);
//4
	pMoon = pPlanet->CreateChild();
	pMoon->SetPlanetName("Draco");
	pMoon->SetOrbitDistance(0.9);
	pMoon->SetRadius(0.2);
	pMoon->SetOrbitSpeed(60.0);
	pMoon->SetResolution(20, 20);
//5
	pPlanet = pSun->CreateChild();
	pPlanet->SetPlanetName("Regulus");
	pPlanet->SetOrbitDistance(7.5);
	pPlanet->SetRadius(0.5);
	pPlanet->SetOrbitSpeed(45.0);
	pPlanet->SetMaterialProperty(GL_AMBIENT_AND_DIFFUSE,pAmb);
	pPlanet->SetRotationalSpeed(40.0);
	pPlanet->SetPlaneTilt(-20.0, pTiltAxis);
	pPlanet->SetCurOrbit(60.0);
	pPlanet->SetResolution(20, 20);
//6
	pPlanet = pSun->CreateChild();
	pPlanet->SetPlanetName("Merope");
	pPlanet->SetOrbitDistance(10.0);
	pPlanet->SetRadius(1.1);
	pPlanet->SetOrbitSpeed(90.0);
	pPlanet->SetPlaneTilt(-50.0, pTiltAxis);
	pPlanet->SetMaterialProperty(GL_AMBIENT_AND_DIFFUSE,pAmb);
	pPlanet->SetRotationalSpeed(-30.0);
	pPlanet->SetCurOrbit(180.0);
//7
	pMoon = pPlanet->CreateChild();
	pMoon->SetPlanetName("Minhar");
	pMoon->SetOrbitDistance(2.0);
	pMoon->SetRadius(0.3);
	pMoon->SetOrbitSpeed(1.0);
	pMoon->SetRotationalSpeed(180.0);
	pMoon->SetResolution(20, 20);
//8
	pMoon = pPlanet->CreateChild();
	pMoon->SetPlanetName("Atria");
	pMoon->SetOrbitDistance(3.5);
	pMoon->SetRadius(0.6);
	pMoon->SetOrbitSpeed(180.0);
	pMoon->SetRotationalSpeed(1.0);
	pMoon->SetResolution(20, 20);
//9
	pMoon = pMoon->CreateChild();
	pMoon->SetPlanetName("Lupin");
	pMoon->SetOrbitDistance(4.5);
	pMoon->SetRadius(0.3);
	pMoon->SetOrbitSpeed(180.0);
	pMoon->SetRotationalSpeed(1.0);
	pMoon->SetResolution(20, 20);
// 10 

	pMoon = pMoon->CreateChild();
	pMoon->SetPlanetName("Andromeda");
	pMoon->SetOrbitDistance(2.5);
	pMoon->SetRadius(0.2);
	pMoon->SetOrbitSpeed(60.0);
	pMoon->SetRotationalSpeed(2.0);
	pMoon->SetResolution(20, 20);
//11
	pPlanet = pSun->CreateChild();
	pPlanet->SetPlanetName("Electra");
	pPlanet->SetOrbitDistance(3.0);
	pPlanet->SetRadius(0.2);
	pPlanet->SetOrbitSpeed(100.0);
	pPlanet->SetPlaneTilt(90, pTiltAxis3);
//12
	pPlanet = pSun->CreateChild();
	pPlanet->SetPlanetName("Arrakis");
	pPlanet->SetOrbitDistance(9.0);
	pPlanet->SetRadius(0.6);
	pPlanet->SetOrbitSpeed(60.0);
	pPlanet->SetPlaneTilt(70, pTiltAxis);

}

void Init()
{
	glClearColor(0.0, 0.0, 0.0, 1.0);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	CreateSolarSystem();
}

void OnDisplay()
{
	float pLightPos[] = {0.0, 0.0, 0.0, 1.0};
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glLightfv(GL_LIGHT0, GL_POSITION, pLightPos);
	pSun->Update();
	glutSwapBuffers();
}

void OnReshape(int width, int height)
{
	glViewport(0, 0, width, height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	gluPerspective(80.0, static_cast<float>(width)/static_cast<float>(height),
		1.0, 90.0);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	gluLookAt(30.0, 6.0, 0.0, 0.0, 5.0, 0.0, 0.0, 1.0, 0.0);
	glutPostRedisplay();
}

void OnIdle()
{
	static int nLastTime = GetTime();
	static int nFrameCount = 0;

	if (nFrameCount++ == 100)
	{
		float fFPS = 100000.0f/static_cast<float>(GetTime() - nLastTime);
		char Title[256];

		sprintf_s(Title, "Solar system", fFPS);
		glutSetWindowTitle(Title);

		nFrameCount = 0;
		nLastTime = GetTime();
	}

	glutPostRedisplay();
}

void keyboard(unsigned char key, int x, int y)
{
   switch (key) {
      case 27:
         exit(0);
         break;
   }
}

void mouse(int button, int state,int x, int y)
    {
		if (button == GLUT_LEFT_BUTTON && state == GLUT_DOWN)
		{
			//char * TitleMsg = {"FLOORPLAN DESIGNER v0.2"};
			onClick(GLUT_STROKE_ROMAN);

		}
    }

void onClick(void *font)
{
	//handles the getting of the name for the planet based on location
	const char *c;
	string test = pSun ->GetPlanetName(test);
	c = test.c_str();
    float x = 0.0, y = 0.0, z = 0.0;
	glPushMatrix();
	glTranslatef(x, y, z);

	for (c=c; *c != '\0'; c++) 
	{
		glutBitmapCharacter(font, *c);
	}
	glPopMatrix();
	}

void strokeString( float x, float y, float z, float ht, char *s )
{
	char c;			// one character to print
	float sf;		// the scale factor

	glPushMatrix();
		glTranslatef( (GLfloat)x, (GLfloat)y, (GLfloat)z );
		sf = ht / ( 119.05 + 33.33 );
		glScalef( (GLfloat)sf, (GLfloat)sf, (GLfloat)sf );
		for( ; ( c = *s ) != '\0'; s++ )
		{
			glutStrokeCharacter( GLUT_STROKE_ROMAN, c );
		}
	glPopMatrix();
}


int GetTime()
{
	timeb t;
	ftime(&t);
	return 1000 * t.time + t.millitm;
}
